﻿local AffDots = LibStub( "AceAddon-3.0" ):NewAddon("AffDots","AceEvent-3.0")
local SharedMedia = LibStub("LibSharedMedia-3.0")
local AffDotsConfig = LibStub("AceConfig-3.0")

local mastery, haste, crit, spd 	= 0, 0, 0, 0
local me,class,spec					= 0, 0, 0
local timer, throttle				= 0, 0.1
local dot_damage, targets			= {},{}
local track							= {}
local in_combat						= false
local everlasting_affliction		= 1
local colors
local _,player_resource_id, primary_resource_treshold, execute_percent
local UpdateFrames
local spells = {
	corr = GetSpellInfo(172),
	agony = GetSpellInfo(980),
	ua = GetSpellInfo(30108),
}

local opt

local defaults = {
	version_num	= 11804,
	debugaddon	= false,
	locked		= false,
	affliction	= true,
	demonology	= true,
	hide 		= false,
	layout 		= "horizontal",
	reltext 	= true,
	hide_text	= false,
	hide_icons	= false,
	focus 		= false,
	coe 		= false,
	hp 			= false,
	haunt 		= false,
	color1		= {0,0.5,0},
	color2 		= {0.5,0.5,0},
	color3 		= {0.5,0.5,0},
	color4 		= {0.2,0.2,1},
	color5 		= {0.5,0,0},
	color6		= {0.5,0,0},
	color7		= {0,0,0},
	color8		= {0.2,0.2,0.2},
	color9		= {0,0.5,0},
	color10		= {0.5,0.5,0.5},
	text_color	= {1,0.8,0},
	agony_order = 0,
	corr_order 	= 1,
	ua_order 	= 2,
	haunt_order = 3,
	demo_corr 	= 0,
	demo_doom 	= 1,
	destro_immo	= 0,
	scale 		= 1,
	focus_scale = 0.8,
	color_switch= 1.2,
	transparency= 0.5,
	font		= "Fonts\\FRIZQT__.TTF",
	bg			= "Interface\\TARGETINGFRAME\\UI-StatusBar",
	large_text_size = 14,
	small_text_size = 10,
	color_text		= false,
	boxes_v		= {
		icon_size		= 30,
		icon_position	=  5,
		text_position	= 45,
		h				= 40,
		w				= 80,
	},
	boxes_h		= {
		icon_size		= 30,
		icon_position	= 35,
		text_position	= 12,
		h				= 70,
		w				= 40,
	},
	bars		= {
		h				= 20,
		w				= 200,
		margin			= 1,
		pandemic		= 1,
		text_position	= 0,
		proportional	= false,
		limit			= 24,
	},
	tidyplates	= {
		enable			= false,
		w				= 20,
		h				= 20,
		transparency	= 0.8,
		max_targets		= 10,
	},
	burst		= {
		enable			= false,
		default			= {100, 100, 100},
		switch			= 1.25,
		color			= {0,1,0},
		text			= false,
		h				= 20,
		w				= 80,
	}
}
if not opt then opt = defaults end

local GetTime 				= GetTime
local GetMastery 			= GetMastery
local GetRangedHaste 		= GetRangedHaste
local GetSpellCritChance	= GetSpellCritChance
local GetSpellBonusDamage 	= GetSpellBonusDamage
local UnitDebuff 			= UnitDebuff
local UnitHealth 			= UnitHealth
local UnitHealthMax 		= UnitHealthMax
local UnitExists			= UnitExists
local UnitGUID				= UnitGUID
local math_floor			= math.floor

local m		= AffDotsTarget
local f		= AffDotsFocus
local burst	= CreateFrame("Frame", nil, UIParent)
burst.bg	= burst:CreateTexture()
burst.text	= burst:CreateFontString()
m:SetClampedToScreen(true)
f:SetClampedToScreen(true)
burst:SetClampedToScreen(true)

local function CreateStatusbar(f)
	f.statusbar = CreateFrame("StatusBar", nil, f)
	f.statusbar:SetFrameStrata("MEDIUM")
	f.statusbar:SetFrameLevel(2)
end
--<Statusbar name="$parentStatusbar" parentKey="statusbar" inherits=" CastingBarFrameTemplate"/>
CreateStatusbar(m.f1)
CreateStatusbar(m.f2)
CreateStatusbar(m.f3)
CreateStatusbar(m.f4)
CreateStatusbar(f.f1)
CreateStatusbar(f.f2)
CreateStatusbar(f.f3)
CreateStatusbar(f.f4)

m:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving()
		self.isMoving = true
	end
end)
m:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint()
	opt.p = p
	opt.rp = rp
	opt.x = x
	opt.y = y
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end)
f:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving()
		self.isMoving = true
	end
end)
f:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint()
	opt.focus_p = p
	opt.focus_rp = rp
	opt.focus_x = x
	opt.focus_y = y
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end)
burst:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving()
		self.isMoving = true
	end
end)
burst:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint()
	opt.burst.p = p
	opt.burst.rp = rp
	opt.burst.x = x
	opt.burst.y = y
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end)

local function EverlastingAffliction()
	everlasting_affliction = 1
	for i=1,6 do
	local _,_,_,glyphSpell,_ = GetGlyphSocketInfo(i)
		if glyphSpell == 118778 then everlasting_affliction = 1.5 end
	end
end

local function Nothing() end
local function Round(num) return math_floor(num+.5) end
local function SecondsRound(num)
	if num > 2 then return math_floor(num+.5)
	else return math_floor(num*10+.5)/10 end
end
local function tablecopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[tablecopy(orig_key)] = tablecopy(orig_value)
        end
    else
        copy = orig
    end
    return copy
end

local function CombatLog(_,_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_, ...)
	if(source_GUID ~= me or (event_type ~= "SPELL_AURA_REFRESH" and event_type ~= "SPELL_AURA_APPLIED" and event_type ~= "SPELL_DAMAGE")) then
		return
	end
	spell = select(1, ...)
	if spec == 1 then
		if(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
			if(spell == 30108) then
				targets[dest_GUID.."30108"] = {dot_damage["30108"][1],GetTime(),dot_damage["30108"][2]}
			elseif(spell == 172 or spell == 87389) then
				targets[dest_GUID.."172"] = {dot_damage["172"][1],GetTime(),dot_damage["172"][2]}
			elseif(spell == 980) then
				targets[dest_GUID.."980"] = {dot_damage["980"][1],GetTime(),dot_damage["980"][2],0}
			end
		elseif(event_type == "SPELL_DAMAGE" and spell == 77799) then
			targets[dest_GUID.."172"] = {dot_damage["172"][1],GetTime(),dot_damage["172"][2]}
			targets[dest_GUID.."30108"] = {dot_damage["30108"][1],GetTime(),dot_damage["30108"][2]}
		end
	elseif spec == 2 then
		if(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
			if(spell == 172) then
				targets[dest_GUID.."172"] = {dot_damage["172"][1],GetTime(),dot_damage["172"][2]}
			elseif(spell == 603) then
				targets[dest_GUID.."603"] = {dot_damage["603"][1],GetTime(),dot_damage["603"][2]}
			end
		elseif(event_type == "SPELL_DAMAGE" and (spell == 103964 or spell == 77799 or spell == 115422)) then
			targets[dest_GUID.."172"] = {dot_damage["172"][1],GetTime(),dot_damage["172"][2]}
		end
	elseif spec == 3 then
		
	end
end

local function GetDotDmg()
	local mas = GetMastery()
	local has = GetRangedHaste()
	local cri = GetSpellCritChance(6)
	local dmg = GetSpellBonusDamage(6)
	if( mas ~= mastery or has ~= haste or cri ~= crit or dmg ~= spd) then
		mastery = mas;
		haste 	= has;
		crit 	= cri;
		spd 	= dmg;
	else
		return
	end

	local damage_bonus, tick_every, ticks, duration, damage, dps, bonus
	if spec==1 then --Affliction
		damage_bonus 		= (1+crit/100)*(1+(mastery*3.1)/100)
		tick_every 			= 2/(1+(haste/100))

		ticks 				= Round(24/tick_every)
		duration 			= ticks * tick_every
		damage				= ticks*(280+spd*0.26)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage["980"]	= {Round(dps/100)/10, tick_every}

		ticks 				= Round(18/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1926+ticks*spd*0.2)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage["172"]	= {Round(dps/100)/10, tick_every}

		ticks 				= Round(14/tick_every)
		duration 			= ticks * tick_every
		damage 				= (1792+ticks*spd*0.24)*damage_bonus
		dps		 			= Round(damage/duration)
		dot_damage["30108"]	= {Round(dps/100)/10, tick_every}
	elseif spec==2 then --Demonology
		damage_bonus 		= (1+crit/100)*(1+(mastery)/100)
		bonus			= (1+crit/100)*(1+(mastery*3)/100)

		tick_every 			= 2/(1+(haste/100))
		ticks 				= Round(18/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1926+ticks*spd*0.2)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage["172"]	= {Round(dps/100)/10, tick_every}

		tick_every 			= 15/(1+(haste/100))
		ticks 				= Round(60/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1068+spd)*bonus*ticks
		dps					= Round(damage/duration)
		dot_damage["603"]	= {Round(dps/100)/10, tick_every}
	elseif spec==3 then --Destruction
		damage_bonus 		= (1+crit/100)*(1+(mastery+1)/100)
		bonus				= (100+mastery*3)*0.35/100

		tick_every 			= 3/(1+(haste/100))
		ticks 				= Round(15/tick_every)
		duration 			= ticks * tick_every
		damage		 		= (1980+ticks*spd*0.371)*damage_bonus
		dps					= Round(damage/duration)
		dot_damage["348"]	= {Round(dps/100)/10, tick_every}
		dot_damage["108686"]= {Round(dps*bonus/100)/10, tick_every}
	end
end

local function UpdateBarFrames(f)
	local color = 7
	if f.t == "dot" then		
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target, f.name,f.rank,"player")
		if duration then
			local current 		= dot_damage[f.spell][1]
			if not targets[UnitGUID(f.target)..f.spell_id] then return false end
			local on_target 	= targets[UnitGUID(f.target)..f.spell_id][1]
			local duration_left = expires - GetTime()
			if		(on_target  < current and duration_left <= f.pandemic) then color = 1
			elseif 	(on_target == current and duration_left <= f.pandemic) then color = 2
			elseif	(on_target  > current and duration_left <= f.pandemic) then color = 3
			elseif	(on_target*opt.color_switch < current and duration_left  > f.pandemic) then color = 4
			elseif	(on_target  > current and duration_left  > f.pandemic) then color = 6
			else color = 5
			end
			if(f.spell_id == 980 and targets[UnitGUID(f.target)..f.spell_id][4] == 0) then
				targets[UnitGUID(f.target).."980"][4] = expires
			elseif(f.spell_id == 980 and expires - targets[UnitGUID(f.target)..f.spell_id][4] > 1) then
				targets[UnitGUID(f.target).."980"][1] = dot_damage["980"][1]
				targets[UnitGUID(f.target).."980"][3] = dot_damage["980"][2]
			end
			f.bg:SetVertexColor(colors[8][1],colors[8][2],colors[8][3],1)
			f.statusbar:SetValue(duration_left)
			f.statusbar:SetStatusBarColor(colors[color][1],colors[color][2],colors[color][3],1)
			if opt.bars.proportional then
				f.tick:SetPoint("LEFT",opt.bars.w*targets[UnitGUID(f.target)..f.spell_id][3]/opt.bars.limit,0)
			else
				f.tick:SetPoint("LEFT",opt.bars.w*targets[UnitGUID(f.target)..f.spell_id][3]/f.duration,0)
			end
			f.tick:Show()
			if opt.color_text then f.t1:SetTextColor(colors[color][1],colors[color][2],colors[color][3]) end
			if opt.reltext then f.t1:SetText(Round(current*100/on_target))
			else f.t1:SetText(current.."/"..on_target) end
			if(expires-f.timer>1) then
				f.timer = expires
			end
			f.t2:SetText(SecondsRound(f.timer-GetTime()))
		else
			f.bg:SetVertexColor(colors[8][1],colors[8][2],colors[8][3],1)
			f.statusbar:SetStatusBarColor(colors[color][1],colors[color][2],colors[color][3],1)
			f.statusbar:SetValue(0)
			f.tick:Hide()
			f.t1:SetText(0)
			f.t2:SetText("")
			f.timer = 0
			if opt.color_text then f.t1:SetTextColor(opt.text_color[1],opt.text_color[2],opt.text_color[3]) end
		end
	elseif f.t == "debuff" then
		local bg_color = 8
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target, f.name,"","player")
		if f.resource then
			if(UnitPower("player", player_resource_id) >= primary_resource_treshold) then
				bg_color = 9
			end
			f.t1:SetText(UnitPower("player", player_resource_id))
		end
		if(expires) then
			color = 9
			bg_color = 8
			f.statusbar:SetValue((expires - GetTime()))
			if(expires-f.timer>1) then
				f.timer = expires
			end
			f.t2:SetText(SecondsRound(f.timer-GetTime()))
		else
			f.statusbar:SetValue(0)
			f.t2:SetText("")
			f.timer = 0
		end
		f.bg:SetVertexColor(colors[bg_color][1],colors[bg_color][2],colors[bg_color][3],1)
		f.statusbar:SetStatusBarColor(colors[color][1],colors[color][2],colors[color][3],1)
	elseif f.t == "hp" then
		if UnitExists(f.target) then
			local hp = Round(UnitHealth(f.target)*100/UnitHealthMax(f.target))
			f.t1:SetText(hp)
			if execute_percent >= hp then
				color = 9
			end
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],opt.transparency)
	elseif f.t == "coe" then
		local _,_,_,_,_,_,expires1 = UnitDebuff(f.target, f.coe)
		local _,_,_,_,_,_,expires2 = UnitDebuff(f.target, f.poison)
		local expires = expires1 or expires2
		if expires then
			local time_remaining = expires - GetTime()
			if 		time_remaining>60 	then f.t1:SetText((math_floor(time_remaining/60)+1).."m")
			elseif 	time_remaining>10	then f.t1:SetText("0:" ..math_floor(time_remaining))
			else 							 f.t1:SetText("0:0"..math_floor(time_remaining))
			end
			f.bg:SetTexture(colors[9][1],colors[9][2],colors[9][3],opt.transparency)
		else
			f.t1:SetText("")
			f.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],opt.transparency)
		end
	elseif f.t == "burst" then
		local current = 0
		local target = UnitGUID("target")
		if not target then
			
		elseif spec == 1 then
			local _,_,_,_,_,_,expires1 = UnitDebuff("target", spells.corr,nil,"player")
			local _,_,_,_,_,_,expires2 = UnitDebuff("target", spells.agony,nil,"player")
			local _,_,_,_,_,_,expires3 = UnitDebuff("target", spells.ua,nil,"player")
			if expires1 and targets[target.."172"] then current = current + targets[target.."172"][1] end
			if expires2 and targets[target.."980"] then current = current + targets[target.."980"][1] end
			if expires3 and targets[target.."30108"] then current = current + targets[target.."30108"][1] end
		elseif spec == 2 then
			current = dot_damage["172"][1]
		elseif spec == 3 then
			current = dot_damage["348"][1]
		end
		local damage = current/opt.burst.default[spec]
		if damage > opt.burst.switch then
			burst.bg:SetTexture(opt.burst.color[1],opt.burst.color[2],opt.burst.color[3],opt.transparency);
		else
			burst.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],opt.transparency);
		end
		burst.text:SetText(Round(damage*100))
	end
end

local function UpdateBlockFrames(f)
	local color = 7
	if f.t == "dot" then
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target, f.name,f.rank,"player")
		if duration then
			local current 		= dot_damage[f.spell][1]
			if not targets[UnitGUID(f.target)..f.spell_id] then return false end
			local on_target 	= targets[UnitGUID(f.target)..f.spell_id][1]
			local duration_left = expires - GetTime()
			if		(on_target  < current and duration_left <= f.pandemic) then color = 1
			elseif 	(on_target == current and duration_left <= f.pandemic) then color = 2
			elseif	(on_target  > current and duration_left <= f.pandemic) then color = 3
			elseif	(on_target*opt.color_switch < current and duration_left  > f.pandemic) then color = 4
			elseif	(on_target  > current and duration_left  > f.pandemic) then color = 6
			else color = 5
			end
			if(f.spell_id == 980 and targets[UnitGUID(f.target)..f.spell_id][4] == 0) then
				targets[UnitGUID(f.target).."980"][4] = expires
			elseif(f.spell_id == 980 and expires - targets[UnitGUID(f.target)..f.spell_id][4] > 1) then
				targets[UnitGUID(f.target).."980"][1] = dot_damage["980"][1]
				targets[UnitGUID(f.target).."980"][3] = dot_damage["980"][2]
			end
			if opt.color_text then f.t1:SetTextColor(colors[color][1],colors[color][2],colors[color][3]) end
			if not opt.hide_icons then f.cd:SetCooldown(expires-duration, duration) end
			if opt.reltext then f.t1:SetText(Round(current*100/on_target))
			else f.t1:SetText(current.."|n"..on_target) end
		else
			if opt.color_text then f.t1:SetTextColor(opt.text_color[1],opt.text_color[2],opt.text_color[3]) end
			f.cd:Hide()
			f.t1:SetText(0)
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],opt.transparency)
	elseif f.t == "debuff" then
		local _,_,_,_,_,duration,expires = UnitDebuff(f.target, f.name,"","player")
		if f.resource then
			if(UnitPower("player", player_resource_id) >= primary_resource_treshold) then
				color = 9
			end
			f.t1:SetText(UnitPower("player", player_resource_id))
		end
		if(expires) then
			if not opt.hide_icons then f.cd:SetCooldown(expires-duration, duration);f.cd:Show(); end
		else
			f.cd:Hide();
		end
		f.bg:SetTexture(colors[color][1],colors[color][2],colors[color][3],opt.transparency)
	elseif f.t == "hp" then
		f.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],opt.transparency)
		if UnitExists(f.target) then
			local hp = Round(UnitHealth(f.target)*100/UnitHealthMax(f.target))
			f.t1:SetText(hp)
			if execute_percent >= hp then
				f.bg:SetTexture(colors[9][1],colors[9][2],colors[9][3],opt.transparency)
			end
		end
	elseif f.t == "coe" then
		local _,_,_,_,_,_,expires1 = UnitDebuff(f.target, f.coe)
		local _,_,_,_,_,_,expires2 = UnitDebuff(f.target, f.poison)
		local expires = expires1 or expires2
		if expires then
			local time_remaining = expires - GetTime()
			if 		time_remaining>60 	then f.t1:SetText((math_floor(time_remaining/60)+1).."m")
			elseif 	time_remaining>10	then f.t1:SetText("0:" ..math_floor(time_remaining))
			else 							 f.t1:SetText("0:0"..math_floor(time_remaining))
			end
			f.bg:SetTexture(colors[9][1],colors[9][2],colors[9][3],opt.transparency)
		else
			f.t1:SetText("")
			f.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],opt.transparency)
		end
	elseif f.t == "burst" then
		local current = 0
		local target = UnitGUID("target")
		if not target then
			
		elseif spec == 1 then
			local _,_,_,_,_,_,expires1 = UnitDebuff("target", spells.corr,nil,"player")
			local _,_,_,_,_,_,expires2 = UnitDebuff("target", spells.agony,nil,"player")
			local _,_,_,_,_,_,expires3 = UnitDebuff("target", spells.ua,nil,"player")
			if expires1 and targets[target.."172"] then current = current + targets[target.."172"][1] end
			if expires2 and targets[target.."980"] then current = current + targets[target.."980"][1] end
			if expires3 and targets[target.."30108"] then current = current + targets[target.."30108"][1] end
		elseif spec == 2 then
			current = dot_damage["172"][1]
		elseif spec == 3 then
			current = dot_damage["348"][1]
		end
		local damage = current/opt.burst.default[spec]
		if damage > opt.burst.switch then
			burst.bg:SetTexture(opt.burst.color[1],opt.burst.color[2],opt.burst.color[3],opt.transparency);
		else
			burst.bg:SetTexture(colors[7][1],colors[7][2],colors[7][3],opt.transparency);
		end
		burst.text:SetText(Round(damage*100))
	end
end

local function Movable(lock)
	m:SetMovable(lock)
	m:EnableMouse(lock)
	f:SetMovable(lock)
	f:EnableMouse(lock)
	burst:SetMovable(lock)
	burst:EnableMouse(lock)
end

local function Visibility()
	if(opt.hide and not in_combat) then
		m:Hide(); burst:Hide()
	else
		m:Show(); if opt.burst.enable then burst:Show() end
	end

	if(UnitGUID("focus") and opt.focus and (in_combat or not opt.hide)) then
		f:Show()
	else
		f:Hide()
	end
end

local function AffDotsTrack(id,stype,target,duration,frame,resource,order,active)
	if not active then return end
	local spell = {}
	if(stype ~= "coe" and stype ~= "hp") then
		local n,r,i = GetSpellInfo(id)
		spell["duration" ]	= duration*everlasting_affliction*1.5
		spell["pandemic" ]	= duration*everlasting_affliction/2
		spell["name"	 ]	= n
		spell["rank"	 ]	= r
		spell["iconfile" ]	= i
		spell["spell_id" ]	= id
		spell["spell"	 ]	= tostring(id)
		spell["resource" ]	= resource
		spell["icon"	 ]	= frame.icon
		spell["statusbar"]	= frame.statusbar
		spell["pandemict"]	= frame.pandemict
		spell["tick"	 ]	= frame.tick
		spell["cd"		 ]	= frame.cd
		spell["timer"	 ]	= 0
	end
	if(id == 48181) then
		spell["duration" ]	= 8
	end
	spell["frame"	] 	= frame
	spell["t"		]	= stype
	spell["target"	]	= target
	spell["order"	]	= order
	spell["bg"		]	= frame.bg
	spell["t1"		]	= frame.t1
	spell["t2"		]	= frame.t2

	if stype == "coe" then
		spell["coe"] = GetSpellInfo(1490)
		spell["poison"] = GetSpellInfo(93068)
	end
	tinsert(track, spell)
end

function InitFrames()
	local font		= SharedMedia:Fetch("font", opt.font)
	local statusbar = SharedMedia:Fetch("statusbar", opt.bg)
	wipe(track)
	if spec ~= 1 and spec ~= 2 and spec ~= 3 then m:Hide(); f:Hide(); burst:Hide(); return end
	m:ClearAllPoints();f:ClearAllPoints()
	m:Show(); if opt.focus then f:Show() end
	local height = 2;
	if spec == 1 then
		height = 3
		if opt.haunt then height = 4 end
	end
	if(opt.layout == "horizontal") then
		UpdateFrames = UpdateBlockFrames
		throttle = 0.1
		m:SetSize(height*opt.boxes_h.w*opt.scale, opt.boxes_h.h*opt.scale)
		f:SetSize(height*opt.boxes_h.w*opt.focus_scale, opt.boxes_h.h*opt.focus_scale)
	elseif(opt.layout == "vertical") then
		UpdateFrames = UpdateBlockFrames
		throttle = 0.1
		m:SetSize(opt.boxes_v.w*opt.scale, height*opt.boxes_v.h*opt.scale)
		f:SetSize(opt.boxes_v.w*opt.focus_scale, height*opt.boxes_v.h*opt.focus_scale)
	elseif(opt.layout == "bars") then
		UpdateFrames = UpdateBarFrames
		throttle = 0.05
		m:SetSize(opt.bars.w*opt.scale, height*(opt.bars.h+opt.bars.margin)*opt.scale)
		f:SetSize(opt.bars.w*opt.focus_scale, height*(opt.bars.h+opt.bars.margin)*opt.focus_scale)
	end
	if(opt.x and opt.y and opt.p and opt.rp) then
		m:SetPoint(opt.p, nil, opt.rp, opt.x, opt.y)
	else
		m:SetPoint("CENTER", 0, 0)
	end
	if(opt.focus_x and opt.focus_y and opt.focus_p and opt.focus_rp) then
		f:SetPoint(opt.focus_p, nil, opt.focus_rp, opt.focus_x, opt.focus_y)
	else
		f:SetPoint("CENTER", 0, 100)
	end
	m.f1:Hide();m.f2:Hide();m.f3:Hide();m.f4:Hide();m.f5:Hide();m.f6:Hide();
	m.f1:SetScale(opt.scale);m.f2:SetScale(opt.scale);m.f3:SetScale(opt.scale);
	m.f4:SetScale(opt.scale);m.f5:SetScale(opt.scale);m.f6:SetScale(opt.scale);
	f.f1:Hide();f.f2:Hide();f.f3:Hide();f.f4:Hide();f.f5:Hide();f.f6:Hide();
	f.f1:SetScale(opt.focus_scale);f.f2:SetScale(opt.focus_scale);f.f3:SetScale(opt.focus_scale);
	f.f4:SetScale(opt.focus_scale);f.f5:SetScale(opt.focus_scale);f.f6:SetScale(opt.focus_scale);

	if spec == 1 then
		if not opt.affliction then return end
		player_resource_id	= 7; primary_resource_treshold = 4; execute_percent = 20;
		AffDotsTrack(   172,	"dot","target",18,m.f1,false, opt.corr_order,			 true)
		AffDotsTrack(   980,	"dot","target",24,m.f2,false,opt.agony_order,		 	 true)
		AffDotsTrack( 30108,	"dot","target",14,m.f3,false,   opt.ua_order,			 true)
		AffDotsTrack( 48181, "debuff","target", 0,m.f4,true ,opt.haunt_order,       opt.haunt)
		AffDotsTrack( 	  0,	 "hp","target", 0,m.f5,false,					 0,    opt.hp)
		AffDotsTrack( 	  0,	"coe","target", 0,m.f6,false,					 1,   opt.coe)
		if opt.focus then
		AffDotsTrack(   172,	"dot", "focus",18,f.f1,false, opt.corr_order,			 true)
		AffDotsTrack(   980,	"dot", "focus",24,f.f2,false,opt.agony_order,		 	 true)
		AffDotsTrack( 30108,	"dot", "focus",14,f.f3,false,   opt.ua_order,			 true)
		AffDotsTrack( 48181, "debuff", "focus", 0,f.f4,true ,opt.haunt_order,       opt.haunt)
		AffDotsTrack( 	  0,	 "hp", "focus", 0,f.f5,false,					 0,    opt.hp)
		AffDotsTrack( 	  0,	"coe", "focus", 0,f.f6,false,					 1,   opt.coe)
		end
	elseif spec == 2 then
		if not opt.demonology then return end
		player_resource_id	= 15; primary_resource_treshold = 800; execute_percent = 20;
		AffDotsTrack(   172,	"dot","target",18,m.f1,false, opt.demo_corr,			 true)
		AffDotsTrack(   603,	"dot","target",60,m.f2,false, opt.demo_doom,		 	 true)
		AffDotsTrack( 	  0,	 "hp","target", 0,m.f5,false,					0,     opt.hp)
		AffDotsTrack( 	  0,	"coe","target", 0,m.f6,false,					1,    opt.coe)
		if opt.focus then
		AffDotsTrack(   172,	"dot", "focus",18,f.f1,false, opt.demo_corr,			 true)
		AffDotsTrack(   603,	"dot", "focus",60,f.f2,false, opt.demo_doom,		 	 true)
		AffDotsTrack( 	  0,	 "hp", "focus", 0,f.f5,false,					0,     opt.hp)
		AffDotsTrack( 	  0,	"coe", "focus", 0,f.f6,false,					1,    opt.coe)
		end
	elseif spec == 3 then
		m:Hide(); f:Hide();
	end
	
	--layout
	for k,v in pairs(track) do
		local c = track[k]
		c.t1:SetTextColor(opt.text_color[1],opt.text_color[2],opt.text_color[3])
		c.t2:SetTextColor(opt.text_color[1],opt.text_color[2],opt.text_color[3])
		if opt.layout == "horizontal" then
			if(c.t == "dot" or c.t == "debuff") then
				c.bg:SetVertexColor(1,1,1,1)
				c.icon:Hide();c.cd:Hide();c.t1:Hide();c.t2:Hide();c.statusbar:Hide();c.tick:Hide();c.pandemict:Hide();
				c.frame:ClearAllPoints();c.icon:ClearAllPoints();c.t1:ClearAllPoints();c.t2:ClearAllPoints();
				c.t1:SetText("");c.t2:SetText("");
				c.frame:SetSize(opt.boxes_h.w,opt.boxes_h.h)
				c.frame:SetPoint("TOPLEFT", opt.boxes_h.w*c.order, 0)
				c.bg:SetAllPoints(true)
				c.icon:SetTexture(c.iconfile)
				c.icon:SetSize(opt.boxes_h.icon_size,opt.boxes_h.icon_size)
				c.icon:SetTexCoord(0.1,0.9,0.1,0.9)
				c.icon:SetPoint("TOP",0,-opt.boxes_h.icon_position)
				c.t1:SetPoint("TOP",0,-opt.boxes_h.text_position);c.t1:SetFont(font,opt.large_text_size,"OUTLINE")
				c.cd:SetAllPoints(c.icon)
				if not opt.hide_text then c.t1:Show() end
				if not opt.hide_icons then c.icon:Show();c.cd:Show() end
				c.frame:Show();
			elseif (c.t == "coe") then
				c.frame:SetSize(opt.boxes_h.w,22)
				if opt.hp then c.frame:SetPoint("TOPLEFT", opt.boxes_h.w, 22) else c.frame:SetPoint("TOPLEFT",  0, 22) end
				c.frame.t1:SetPoint("CENTER", 0, 0);c.t1:SetFont(font,opt.small_text_size,"OUTLINE")
				c.frame:Show()
			elseif (c.t == "hp") then
				c.frame:SetSize(opt.boxes_h.w,22)
				c.frame:SetPoint("TOPLEFT", 0, 22)
				c.frame.t1:SetPoint("CENTER", 0, 0);c.t1:SetFont(font,opt.small_text_size,"OUTLINE")
				c.frame:Show()
			end
		elseif opt.layout == "vertical" then
			if(c.t == "dot" or c.t == "debuff") then
				c.bg:SetVertexColor(1,1,1,1)
				c.icon:Hide();c.cd:Hide();c.t1:SetText("");c.t1:Hide();c.t2:SetText("");c.t2:Hide();c.statusbar:Hide();c.tick:Hide();c.pandemict:Hide();
				c.frame:ClearAllPoints()
				c.frame:SetSize(opt.boxes_v.w,opt.boxes_v.h)
				c.frame:SetPoint("TOPLEFT", 0, -opt.boxes_v.h*c.order)
				c.bg:SetAllPoints(true)
				c.icon:ClearAllPoints();c.t1:ClearAllPoints();
				c.icon:SetTexture(c.iconfile)
				c.icon:SetSize(opt.boxes_v.icon_size,opt.boxes_v.icon_size)
				c.icon:SetTexCoord(0.1,0.9,0.1,0.9)
				c.icon:SetPoint("LEFT",opt.boxes_v.icon_position,0)
				c.t1:SetPoint("RIGHT",opt.boxes_v.text_position-50,0);c.t1:SetFont(font,opt.large_text_size,"OUTLINE")
				c.cd:SetAllPoints(c.icon)
				if not opt.hide_text then c.t1:Show() end
				if not opt.hide_icons then c.icon:Show();c.cd:Show() end
				c.frame:Show();
			elseif (c.t == "coe") then
				c.frame:SetSize(opt.boxes_v.w/2,22)
				if opt.hp then c.frame:SetPoint("TOPLEFT", opt.boxes_v.w/2, 22) else c.frame:SetPoint("TOPLEFT",  0, 22) end
				c.frame.t1:SetPoint("CENTER", 0, 0);c.t1:SetFont(font,opt.small_text_size,"OUTLINE")
				c.frame:Show()
			elseif (c.t == "hp") then
				c.frame:SetSize(opt.boxes_v.w/2,22)
				c.frame:SetPoint("TOPLEFT", 0, 22)
				c.frame.t1:SetPoint("CENTER", 0, 0);c.t1:SetFont(font,opt.small_text_size,"OUTLINE")
				c.frame:Show()
			end
		elseif opt.layout == "bars" then
			if(c.t == "dot" or c.t == "debuff") then
				c.icon:Hide();c.cd:Hide();c.pandemict:Hide();c.t1:SetText("");c.t1:Hide();c.t2:SetText("");c.t2:Hide();
				c.icon:ClearAllPoints();c.t1:ClearAllPoints();c.tick:ClearAllPoints()
				c.frame:ClearAllPoints();c.pandemict:ClearAllPoints();c.statusbar:ClearAllPoints()
				c.frame:SetSize(opt.bars.w,opt.bars.h)
				c.frame:SetPoint("TOPLEFT",0,-opt.bars.h*c.order-(c.order*opt.bars.margin))
				c.tick:SetPoint("LEFT",0,0)
				c.tick:SetSize(opt.bars.pandemic,opt.bars.h)
				c.tick:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
				c.tick:SetVertexColor(1, 1, 1, 0.75);
				c.statusbar:SetAllPoints(true)
				c.statusbar:SetStatusBarTexture(statusbar)
				c.statusbar:GetStatusBarTexture():SetHorizTile(false)
				c.statusbar:GetStatusBarTexture():SetVertTile(false)
				c.statusbar:SetStatusBarColor(0, 0, 0, opt.transparency)
				if opt.bars.proportional then
					if c.spell_id == 48181 then
						c.pandemict:SetPoint("LEFT",12/opt.bars.limit*opt.bars.w,0)
					else
						c.pandemict:SetPoint("LEFT",c.pandemic/opt.bars.limit*opt.bars.w,0)
					end
					c.statusbar:SetMinMaxValues(0, opt.bars.limit)
				else
					c.pandemict:SetPoint("LEFT",1/3*opt.bars.w,0)
					c.statusbar:SetMinMaxValues(0, c.duration)
				end
				c.pandemict:SetSize(opt.bars.pandemic,opt.bars.h)
				c.pandemict:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
				c.pandemict:SetVertexColor(1, 1, 1, 0.75);
				c.icon:SetTexture(c.iconfile)
				c.icon:SetSize(opt.bars.h,opt.bars.h)
				c.icon:SetTexCoord(0.1,0.9,0.1,0.9)
				c.icon:SetPoint("LEFT",-opt.bars.h,0)
				c.cd:SetAllPoints(c.icon)
				c.t1:SetPoint("CENTER",opt.bars.text_position*(opt.bars.w/100),0);
				c.t1:SetFont(font,opt.large_text_size,"OUTLINE")
				c.t2:SetPoint("RIGHT",-3,0);
				c.t2:SetFont(font,opt.large_text_size,"OUTLINE")
				c.bg:SetAllPoints(true)
				c.bg:SetTexture(statusbar)
				if not opt.hide_text then c.t1:Show();c.t2:Show() end
				if not opt.hide_icons then c.icon:Show(); end
				c.statusbar:Show();c.tick:Hide();c.frame:Show();
				if(opt.bars.pandemic > 0 and (c.t == "dot" or opt.bars.proportional)) then c.pandemict:Show() end
			elseif (c.t == "coe") then
				c.frame:SetSize(40,22)
				if opt.hp then c.frame:SetPoint("TOPLEFT", 40, 22) else c.frame:SetPoint("TOPLEFT",  0, 22) end
				c.frame.t1:SetPoint("CENTER", 0, 0);c.t1:SetFont(font,opt.small_text_size,"OUTLINE")
				c.frame:Show()
			elseif (c.t == "hp") then
				c.frame:SetSize(40,22)
				c.frame:SetPoint("TOPLEFT", 0, 22)
				c.frame.t1:SetPoint("CENTER", 0, 0);c.t1:SetFont(font,opt.small_text_size,"OUTLINE")
				c.frame:Show()
			end
		end
	end
	if opt.burst.enable then
		burst:ClearAllPoints()
		burst:Show()
		burst:SetSize(opt.burst.w, opt.burst.h)
		if opt.burst.x then
			burst:SetPoint(opt.burst.p, nil, opt.burst.rp, opt.burst.x, opt.burst.y)
		else
			burst:SetPoint("CENTER", 0, 0)
		end
		burst.bg:SetAllPoints(true)
		burst.text:SetPoint("CENTER",0,0)
		burst.text:SetFont(font,opt.large_text_size,"OUTLINE")
		burst.text:SetTextColor(opt.text_color[1],opt.text_color[2],opt.text_color[3])
		if opt.burst.text then burst.text:Show() else burst.text:Hide() end
		tinsert(track, {t="burst"})
	else
		burst:Hide()
	end
end

local function CleanTargets(force)
	if force then 
		wipe(targets)
	else
		local t = GetTime()
		for k,v in pairs(targets) do
			if targets[k][2] < t-100 then targets[k]=nil end
		end
	end
end

local function FindColor(GUID,time_left,spell,pandemic)
	local color = 7
	if not targets[GUID..spell] or not dot_damage[tostring(spell)] then
		return colors[color][1],colors[color][2],colors[color][3]
	end
	local current 		= dot_damage[tostring(spell)][1]
	local on_target 	= targets[GUID..spell][1]
	if		(on_target  < current and time_left <= pandemic) then color = 1
	elseif 	(on_target == current and time_left <= pandemic) then color = 2
	elseif	(on_target  > current and time_left <= pandemic) then color = 3
	elseif	(on_target*opt.color_switch < current and time_left  > pandemic) then color = 4
	elseif	(on_target  > current and time_left  > pandemic) then color = 6
	else color = 5
	end
	return colors[color][1],colors[color][2],colors[color][3]
end

local function Tidy()
	local TidyPlates = TidyPlates
	local time_left, icon, spell, pandemic, GUID, r, g, b
	for plate in pairs(TidyPlates.NameplatesByVisible) do
		if not plate.extended.widgets.DebuffWidget then return false end
		GUID = plate.extended.unit.guid
		if GUID then
			for id,frame in pairs(plate.extended.widgets.DebuffWidget.AuraIconFrames) do
				time_left = tonumber(frame.TimeLeft:GetText())
				icon = frame.Icon:GetTexture()
				if 		icon == "Interface\\Icons\\Spell_Shadow_AbominationExplosion" 	then spell =  172; pandemic =  9*everlasting_affliction
				elseif 	icon == "Interface\\Icons\\Spell_Shadow_CurseOfSargeras" 		then spell =  980; pandemic = 12*everlasting_affliction
				elseif	icon == "Interface\\Icons\\Spell_Shadow_UnstableAffliction_3" 	then spell =30108; pandemic =  7*everlasting_affliction
				elseif	icon == "Interface\\Icons\\Spell_Shadow_AuraOfDarkness"			then spell =  603; pandemic = 30*everlasting_affliction
				else	spell = nil
				end
				frame.Icon:SetDrawLayer("ARTWORK")
				frame.Border:SetDrawLayer("BACKGROUND")
				frame.Border:SetSize(opt.tidyplates.w,opt.tidyplates.h)
				frame.Border:SetPoint("CENTER", 0, 0)
				if spell and time_left then
					r,g,b = FindColor(GUID,time_left,spell,pandemic)
					frame.Border:SetTexture(r,g,b,opt.tidyplates.transparency)
				else
					frame.Border:SetTexture(0,0,0,opt.tidyplates.transparency)
				end
			end
		end
	end
end

local function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= throttle then
		for k,v in pairs(track) do
			UpdateFrames(track[k])
		end
		if opt.tidyplates.enable and TidyPlates then Tidy() end
        timer = 0
    end
end

local options_table = {
	type = "group",name = "AffDots (drag here to move options frame)",
	args = {
		lock = {
			order = 1,name = "Lock frames",type = "toggle",
			set = function(info,val) opt.locked = not opt.locked;Movable(not opt.locked) end,
			get = function() return opt.locked end
		},
		reset = {
			order = 1,name = "Reset options",type = "execute",
			func = function()
				AffDotsOptions110 = tablecopy(defaults)
				opt = AffDotsOptions110;
				colors = {opt.color1,opt.color2,opt.color3,opt.color4,opt.color5,opt.color6,opt.color7,opt.color8,opt.color9,opt.color10}
				AffDots:GetLayoutOptions()
				InitFrames()
			end,
		},
		general={
			order = 1,name = "General",type = "group",
			args={
				affliction = {
					order = 1,name = "Affliction",type = "toggle",
					set = function(info,val) opt.affliction = not opt.affliction;InitFrames() end,
					get = function() return opt.affliction end
				},
				demonology = {
					order = 2,name = "Demonology",type = "toggle",
					set = function(info,val) opt.demonology = not opt.demonology;InitFrames() end,
					get = function() return opt.demonology end
				},
				hide = {
					order = 3,name = "Hide when not in combat",type = "toggle",
					set = function(info,val) opt.hide = not opt.hide;InitFrames();Visibility() end,
					get = function(info) return opt.hide end
				},
				hide_icons = {
					order = 4,name = "Hide icons",type = "toggle",
					set = function(info,val) opt.hide_icons = not opt.hide_icons;InitFrames() end,
					get = function(info) return opt.hide_icons end
				},
				hide_text = {
					order = 5,name = "Hide text",type = "toggle",
					set = function(info,val) opt.hide_text = not opt.hide_text;InitFrames() end,
					get = function(info) return opt.hide_text end
				},
				focus = {
					order = 6,name = "Enable focus",type = "toggle",
					set = function(info,val) opt.focus = not opt.focus;InitFrames();Visibility() end,
					get = function(info) return opt.focus end
				},
				coe = {
					order = 7,name = "Enable CoE",type = "toggle",
					set = function(info,val) opt.coe = not opt.coe;InitFrames() end,
					get = function(info) return opt.coe end
				},
				hp = {
					order = 8,name = "Enable HP%",type = "toggle",
					set = function(info,val) opt.hp = not opt.hp;InitFrames() end,
					get = function(info) return opt.hp end
				},
				haunt = {
					order = 9,name = "Enable Haunt",type = "toggle",
					set = function(info,val) opt.haunt = not opt.haunt;InitFrames() end,
					get = function(info) return opt.haunt end
				},
				target_size = {
					order = 10,name = "Target frame size",type = "range",
					min = 0.3,max = 3,step = 0.1,softMin = 0.3,softMax=3,
					set = function(info,val) opt.scale = val;InitFrames() end,
					get = function(info) return opt.scale end
				},
				focus_size = {
					order = 11,name = "Focus frame size",type = "range",
					min = 0.3,max = 3,step = 0.1,softMin = 0.3,softMax=3,
					set = function(info,val) opt.focus_scale = val;InitFrames() end,
					get = function(info) return opt.focus_scale end
				},
				large_text = {
					order = 12,name = "Text size",type = "range",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) opt.large_text_size = val;InitFrames() end,
					get = function(info) return opt.large_text_size end
				},
				small_text = {
					order = 13,name = "CoE/Hp text size",type = "range",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) opt.small_text_size = val;InitFrames() end,
					get = function(info) return opt.small_text_size end
				},
				font = {
					order = 14,name = 'Font',type = 'select',
					dialogControl = 'LSM30_Font',
					values = SharedMedia:HashTable("font"),
					set = function(self,key) opt.font = key;InitFrames() end,
					get = function() return opt.font end,
				},
				layout = {
					order = 15,name = "Layout",type = "select",
					values = {horizontal = "Horizontal", vertical = "Vertical", bars = "Bars"},
					set = function(info,val) opt.layout = val;InitFrames();Visibility();AffDots:GetLayoutOptions() end,
					get = function(info) return opt.layout end
				},
				color_text = {
					order = 16,name = "Change color of text",type = "toggle",width = "full",
					set = function(info,val) opt.color_text = not opt.color_text;InitFrames() end,
					get = function(info) return opt.color_text end
				},
				text_type = {
					order = 17,name = "Relative values",type = "toggle",
					set = function(info,val) opt.reltext = not opt.reltext end,
					get = function(info) return opt.reltext end
				},
			}
		},
		colors={
			order = 2,name = "Colors",type = "group",
			args={
				color1 = {
					order = 1,width = "full",name = "Current stats are better, Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[1]={r,g,b}; opt.color1={r,g,b} end,
					get = function(info) return colors[1][1],colors[1][2],colors[1][3],1 end
				},
				color2 = {
					order = 2,width = "full",name = "Current stats are the same, Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[2]={r,g,b}; opt.color2={r,g,b} end,
					get = function(info) return colors[2][1],colors[2][2],colors[2][3],1 end
				},
				color3 = {
					order = 3,width = "full",name = "Current stats are worse, Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[3]={r,g,b}; opt.color3={r,g,b} end,
					get = function(info) return colors[3][1],colors[3][2],colors[3][3],1 end
				},
				color4 = {
					order = 4,width = "full",name = "Current stats are better, not Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[4]={r,g,b}; opt.color4={r,g,b} end,
					get = function(info) return colors[4][1],colors[4][2],colors[4][3],1 end
				},
				color5 = {
					order = 5,width = "full",name = "Current stats are the same, not Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[5]={r,g,b}; opt.color5={r,g,b} end,
					get = function(info) return colors[5][1],colors[5][2],colors[5][3],1 end
				},
				color6 = {
					order = 6,width = "full",name = "Current stats are worse, not Pandemic safe",type = "color",
					set = function(info,r,g,b) colors[6]={r,g,b}; opt.color6={r,g,b} end,
					get = function(info) return colors[6][1],colors[6][2],colors[6][3],1 end
				},
				color7 = {
					order = 7,width = "full",name = "No dot on target",type = "color",
					set = function(info,r,g,b) colors[7]={r,g,b}; opt.color7={r,g,b};InitFrames() end,
					get = function(info) return colors[7][1],colors[7][2],colors[7][3],1 end
				},
				color9 = {
					order = 8,width = "full",name = "CoE/Hp/Haunt color",type = "color",
					set = function(info,r,g,b) colors[9]={r,g,b}; opt.color9={r,g,b};InitFrames() end,
					get = function(info) return colors[9][1],colors[9][2],colors[9][3],1 end
				},
				text_color = {
					order = 9,width = "full",name = "Text color",type = "color",
					set = function(info,r,g,b) opt.text_color={r,g,b};InitFrames() end,
					get = function(info) return opt.text_color[1],opt.text_color[2],opt.text_color[3],1 end
				},
				color_switch = {
					order = 10,name = "Color switch",type = "range",
					desc = "When refresh is not pandemic safe,\nswitch color only if current stats are at least x% better",
					min = 0,max = 40,step = 1,softMin = 0,softMax=40,
					set = function(info,val) opt.color_switch = 1+val/100 end,
					get = function(info) return (opt.color_switch-1)*100 end
				},
				transparency = {
					order = 11,name = "Transparency",type = "range",
					min = 0,max = 1,step = 0.1,softMin = 0,softMax=1,
					set = function(info,val) opt.transparency = val;InitFrames() end,
					get = function(info) return opt.transparency end
				},
			}
		},
		dotorder={
			order = 3,name = "Order",type = "group",
			args={
				agony = {
					order = 1,name = "Agony",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) opt.agony_order = val - 1;InitFrames() end,
					get = function(info) return opt.agony_order + 1 end
				},
				corr = {
					order = 2,name = "Corruption",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) opt.corr_order = val - 1;InitFrames() end,
					get = function(info) return opt.corr_order + 1 end
				},
				ua = {
					order = 3,name = "UA",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) opt.ua_order = val - 1;InitFrames() end,
					get = function(info) return opt.ua_order + 1 end
				},
				haunt = {
					order = 4,name = "Haunt",type = "range",
					min = 1,max = 4,step = 1,softMin = 1,softMax=4,
					set = function(info,val) opt.haunt_order = val - 1;InitFrames() end,
					get = function(info) return opt.haunt_order + 1 end
				},
			}
		},
		layout={
			order = 4,name = "Layout",type = "group",
			args={}
		},
		tidy_plates={
			order = 6,name = "TidyPlates",type = "group",
			args={
				enable = {
					order = 1,name = "Integrate dot colors in TidyPlates",type = "toggle",width = "full",
					set = function(info,val) opt.tidyplates.enable = not opt.tidyplates.enable end,
					get = function(info) return opt.tidyplates.enable end
				},
				width = {
					order = 2,name = "Width",type = "range",width = "full",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) opt.tidyplates.w = val end,
					get = function(info) return opt.tidyplates.w end
				},
				heigth = {
					order = 5,name = "Heigth",type = "range",width = "full",
					min = 10,max = 30,step = 1,softMin = 10,softMax=30,
					set = function(info,val) opt.tidyplates.h = val end,
					get = function(info) return opt.tidyplates.h end
				},
				transparency = {
					order = 7,name = "Transparency",type = "range",width = "full",
					min = 0,max = 100,step = 10,softMin = 0,softMax=100,
					set = function(info,val) opt.tidyplates.transparency = val/100 end,
					get = function(info) return opt.tidyplates.transparency*100 end
				},
				desc = {
					order = 8,name = "If you want dots to show in certain order in TidyPlates, go to 'Tidy Plates Hub: Tank' and 'Tidy Plates Hub: Damage', find 'Buffs & Debuffs' section, set 'Filter Mode' to 'Specific Auras' and write this in Aura List:\nMy 980\nMy 172\nMy 87389\nMy 30108\nAll 1490\nFirst line is Agony, second and third Corruption, fourth UA, fifth CoE. Reorder them as needed. Put other auras in list if you need them",type = "description",fontSize="medium"
				},
			}
		},
		burst={
			order = 7, name = "Burst", type = "group",
			args={
				desc = {
					order = 1,name = "Compares your current damage to your baseline damage, changes color if increase is at least x% higher.\nIntended to show when you have enough damage increase effects and it is a good time to spend your resources. Set it as high as you possibly can for maximum effect.\nTo save your baseline damage, click 'Set current as baseline' button, make sure you are fully buffed (Dark Intent when solo, party buffed when in 5-man, fully buffed with food and flask in raid) and without active procs or potions. You need to click it once for each spec, when you change gear or some buffs become available or unavailable.\n\nAffliction is special and needs active dots present on target to switch colors, demonology and destruction does not have this requirement.",type = "description",fontSize="medium"
				},
				enable = {
					order = 2,name = "Enable",type = "toggle",width = "full",
					set = function(info,val) opt.burst.enable = not opt.burst.enable; InitFrames() end,
					get = function(info) return opt.burst.enable end
				},
				current = {
					order = 3,name = "Set current as baseline",type = "execute",width = "full",
					func = function()
						if spec == 1 then
							opt.burst.default[1] = dot_damage["172"][1] + dot_damage["980"][1] + dot_damage["30108"][1]
						elseif spec == 2 then
							opt.burst.default[2] = dot_damage["172"][1]
						elseif spec == 3 then
							opt.burst.default[3] = dot_damage["348"][1]
						end
					end,
				},
				switch = {
					order = 4,name = "Damage increase needed to change color (percent)",type = "range",width = "full",
					min = 10,max = 100,step = 1,softMin = 10,softMax=100,
					set = function(info,val) opt.burst.switch = 1+val/100;InitFrames() end,
					get = function(info) return (opt.burst.switch-1)*100 end
				},
				color = {
					order = 5,name = "Color",type = "color",
					set = function(info,r,g,b) opt.burst.color={r,g,b}; InitFrames() end,
					get = function(info) return opt.burst.color[1],opt.burst.color[2],opt.burst.color[3],1 end
				},
				text = {
					order = 6,name = "Show text",type = "toggle",
					set = function(info,val) opt.burst.text = not opt.burst.text;InitFrames() end,
					get = function(info) return opt.burst.text end
				},
				height = {
					order = 7,name = "Height",type = "range",
					min = 10,max = 100,step = 1,softMin = 10,softMax=100,
					set = function(info,val) opt.burst.h = val;InitFrames() end,
					get = function(info) return opt.burst.h end
				},
				width = {
					order = 8,name = "Width",type = "range",
					min = 10,max = 150,step = 1,softMin = 10,softMax=200,
					set = function(info,val) opt.burst.w = val;InitFrames() end,
					get = function(info) return opt.burst.w end
				},
			}
		}
	}
}

function AffDots:GetLayoutOptions()
	if opt.layout == "horizontal" then
		options_table.args.layout.args = {
				icon_size = {
					order = 3,name = "Icon size",type = "range",
					min = 10,max = 60,step = 1,softMin = 10,softMax=60,
					set = function(info,val) opt.boxes_h.icon_size = val;InitFrames() end,
					get = function(info) return opt.boxes_h.icon_size end
				},
				icon_position = {
					order = 4,name = "Icon position",type = "range",
					min = 0,max = 60,step = 1,softMin = 0,softMax=60,
					set = function(info,val) opt.boxes_h.icon_position = val;InitFrames() end,
					get = function(info) return opt.boxes_h.icon_position end
				},
				x_size = {
					order = 5,name = "Height",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) opt.boxes_h.h = val;InitFrames() end,
					get = function(info) return opt.boxes_h.h end
				},
				y_size = {
					order = 6,name = "Width",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) opt.boxes_h.w = val;InitFrames() end,
					get = function(info) return opt.boxes_h.w end
				},
				text_position = {
					order = 7,name = "Text position",type = "range",
					min = 0,max = 100,step = 1,softMin = 0,softMax=100,
					set = function(info,val) opt.boxes_h.text_position = val;InitFrames() end,
					get = function(info) return opt.boxes_h.text_position end
				},
			}
	elseif opt.layout == "vertical" then
		options_table.args.layout.args = {
				icon_size = {
					order = 3,name = "Icon size",type = "range",
					min = 10,max = 60,step = 1,softMin = 10,softMax=60,
					set = function(info,val) opt.boxes_v.icon_size = val;InitFrames() end,
					get = function(info) return opt.boxes_v.icon_size end
				},
				icon_position = {
					order = 4,name = "Icon position",type = "range",
					min = 0,max = 60,step = 1,softMin = 0,softMax=60,
					set = function(info,val) opt.boxes_v.icon_position = val;InitFrames() end,
					get = function(info) return opt.boxes_v.icon_position end
				},
				text_position = {
					order = 6,name = "Text position",type = "range",
					min = 0,max = 100,step = 1,softMin = 0,softMax=100,
					set = function(info,val) opt.boxes_v.text_position = val;InitFrames() end,
					get = function(info) return opt.boxes_v.text_position end
				},
				x_size = {
					order = 7,name = "Horizontal size",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) opt.boxes_v.h = val;InitFrames() end,
					get = function(info) return opt.boxes_v.h end
				},
				y_size = {
					order = 8,name = "Vertical size",type = "range",
					min = 20,max = 100,step = 1,softMin = 20,softMax=100,
					set = function(info,val) opt.boxes_v.w = val;InitFrames() end,
					get = function(info) return opt.boxes_v.w end
				},
			}
	elseif opt.layout == "bars" then
		options_table.args.layout.args = {
				pandemic_width = {
					order = 2,name = "Pandemic indicator width",type = "range",
					min = 0,max = 5,step = 1,softMin = 0,softMax=5,
					set = function(info,val) opt.bars.pandemic = val;InitFrames() end,
					get = function(info) return opt.bars.pandemic end
				},
				text_position = {
					order = 5,name = "Text position",type = "range",
					min = -50,max = 50,step = 1,softMin = -50,softMax=50,
					set = function(info,val) opt.bars.text_position = val;InitFrames() end,
					get = function(info) return opt.bars.text_position end
				},
				bar_height = {
					order = 7,name = "Bar height",type = "range",
					min = 10,max = 100,step = 1,softMin = 10,softMax=100,
					set = function(info,val) opt.bars.h = val;InitFrames() end,
					get = function(info) return opt.bars.h end
				},
				bar_width = {
					order = 8,name = "Bar width",type = "range",
					min = 100,max = 500,step = 1,softMin = 100,softMax=500,
					set = function(info,val) opt.bars.w = val;InitFrames() end,
					get = function(info) return opt.bars.w end
				},
				margin = {
					order = 9,name = "Spacing",type = "range",
					min = 0,max = 10,step = 1,softMin = 0,softMax=10,
					set = function(info,val) opt.bars.margin = val;InitFrames() end,
					get = function(info) return opt.bars.margin end
				},
				bg = {
					order = 10,type = 'select',name = 'Background',
					dialogControl = 'LSM30_Statusbar',
					values = SharedMedia:HashTable("statusbar"),
					set = function(self,key) opt.bg = key;InitFrames() end,
					get = function() return opt.bg end,
				},
				color8 = {
					order = 11,width = "full",name = "Bar background color",type = "color",
					set = function(info,r,g,b) colors[8]={r,g,b}; opt.color8={r,g,b};InitFrames() end,
					get = function(info) return colors[8][1],colors[8][2],colors[8][3],1 end
				},
				color10 = {
					order = 12,width = "full",name = "Pandemic indicator color",type = "color",
					set = function(info,r,g,b) colors[10]={r,g,b}; opt.color10={r,g,b};InitFrames() end,
					get = function(info) return colors[10][1],colors[10][2],colors[10][3],1 end
				},
				proportional = {
					order = 13,name = "Enable proportional bars",type = "toggle",width = "full",
					desc = "All bars will move at the same speed",
					set = function(info,val) opt.bars.proportional = not opt.bars.proportional;InitFrames() end,
					get = function(info) return opt.bars.proportional end
				},
				proportional_limit = {
					order = 14,name = "Proportional bars time limit",type = "range",
					desc = "Maximum numbers of seconds to display in proportional bar",
					min = 20,max = 40,step = 1,softMin = 20,softMax=40,
					set = function(info,val) opt.bars.limit = val;InitFrames() end,
					get = function(info) return opt.bars.limit end
				},
			}
	else
		options_table.args.layout.args = {}
	end
end


SLASH_AFFDOTS1 = '/affdots'
function AffDotsHandler(msg, editBox)
	LibStub("AceConfigDialog-3.0"):Open("AffDots")
end
SlashCmdList["AFFDOTS"] = AffDotsHandler

local function VariablesLoaded()
	AffDotsOptions110 = AffDotsOptions110 or tablecopy(defaults)
	opt = AffDotsOptions110
	if(not opt.version_num or opt.version_num < 11004) then
		AffDotsOptions110 = tablecopy(defaults); opt = AffDotsOptions110;
	end
	if(opt.version_num < 11301) then
		opt.version_num	= 11301
		opt.text_color	= {1,0.8,0}
		opt.tidyplates  = {
			enable			= false,
			w				= 20,
			h				= 20,
			transparency	= 0.8,
			max_targets		= 10,
		}
	end
	if(opt.version_num < 11804) then
		opt.version_num	= 11804
		opt.burst		= {
			enable			= false,
			default			= {100, 100, 100},
			switch			= 1.25,
			color			= {0,1,0},
			text			= false,
			h				= 20,
			w				= 80,
		}
	end
	colors = {opt.color1,opt.color2,opt.color3,opt.color4,opt.color5,opt.color6,opt.color7,opt.color8,opt.color9,opt.color10,opt.color11}
	Movable(not opt.locked)
	Visibility()
end

function AffDots:PLAYER_REGEN_ENABLED()
	in_combat = false; Visibility()
	CleanTargets(false)
end

function AffDots:PLAYER_REGEN_DISABLED()
	in_combat = true; Visibility()
end

function AffDots:PLAYER_FOCUS_CHANGED()
	Visibility()
end

function AffDots:PLAYER_TALENT_UPDATE()
	spec 	= GetSpecialization()
	EverlastingAffliction()
	mastery, haste, crit, spd 	= 0, 0, 0, 0
	GetDotDmg()
	InitFrames()
	Visibility();Movable(not opt.locked)
end

function AffDots:OnInitialize()
	AffDotsConfig:RegisterOptionsTable("AffDots", options_table)
	AffDots:GetLayoutOptions()
end
function AffDots:OnEnable()
	me = UnitGUID("player")
	class 	= select(2, UnitClass("player"))
	spec 	= GetSpecialization()
	if class ~= "WARLOCK" then m:Hide(); f:Hide(); burst:Hide(); return end
	EverlastingAffliction()
	VariablesLoaded()
	GetDotDmg()
	InitFrames()
	Visibility();Movable(not opt.locked)
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", CombatLog)
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("COMBAT_RATING_UPDATE", GetDotDmg)
	self:RegisterEvent("SPELL_POWER_CHANGED", GetDotDmg)
	self:RegisterEvent("UNIT_STATS", GetDotDmg)
	self:RegisterEvent("PLAYER_DAMAGE_DONE_MODS", GetDotDmg)
	self:RegisterEvent("PLAYER_FOCUS_CHANGED")
	m:SetScript("OnUpdate", onUpdate)
end
function AffDots:OnDisable()
	
end