-------------------------------------------------------------------------------
-- ElvUI Improved Spec Switch Datatext By Lockslap
-- <Borderline Amazing> US, Bleeding Hollow
-------------------------------------------------------------------------------
local E, _, V, P, G, _ = unpack(ElvUI)
local L = LibStub("AceLocale-3.0"):GetLocale("ElvUI_ISS", false)

P["impss"] = {
	["switch"] = false,
	["primary"] = "none",
	["secondary"] = "none",
}

E.Options.args.datatexts.args.specswitch = {
	type = "group",
	order = 24,
	name = L["Improved Spec Switch"],
	disabled = function() return GetNumEquipmentSets() == 0 end,
	guiInline = true,
	get = function(info) return E.db.impss[info[#info]] end,
	set = function(info, value) E.db.impss[info[#info]] = value end,
	args = {
		switch = {
			type = "toggle",
			order = 1,
			name = L["Swap Equipment Sets"],
			desc = L["Change equipment sets when you change your spec."],
			disabled = function()
				if not GetSpecialization(false, false, 1) or not GetSpecialization(false, false, 2) then 
					return true
				else
					return false
				end
			end,
		},
		primary = {
			type = "select",
			order = 2,
			name = L["Primary Talents"],
			desc = L["Choose the equipment set to use for your primary spec."],
			disabled = function() return not E.db.impss.switch end,
			values = function()
				local sets = {
					["none"] = L["No Change"],
				}
				for i = 1, GetNumEquipmentSets() do
					local name, _, _, _, _, _, _, _, _ = GetEquipmentSetInfo(i)
					if name then
						sets[name] = name
					end
				end
				sort(sets, function(a, b) return a < b end)
				return sets
			end,
		},
		secondary = {
			type = "select",
			order = 3,
			name = L["Secondary Talents"],
			desc = L["Choose the equipment set to use for your secondary spec."],
			disabled = function() return not E.db.impss.switch end,
			values = function()
				local sets = {
					["none"] = L["No Change"],
				}
				for i = 1, GetNumEquipmentSets() do
					local name, _, _, _, _, _, _, _, _ = GetEquipmentSetInfo(i)
					if name then
						sets[name] = name
					end
				end
				sort(sets, function(a, b) return a < b end)
				return sets
			end,
		},
	},
}
